--- channels/chan_zap.dist.c	2006-08-23 20:14:22.160416000 +0200
+++ channels/chan_zap.c	2006-08-23 23:55:51.363322032 +0200
@@ -2085,6 +2085,32 @@
 				pridialplan = PRI_LOCAL_ISDN;
  			}
  		}
+
+		/* override specified pri dialplan or dynamic pri dialplan
+		   if explicitly defined in the dailed string */
+		switch (*(c + p->stripmsd)) {
+			case 'i':
+				pridialplan = PRI_INTERNATIONAL_ISDN;
+				++c;
+				break;
+			case 'n':
+				pridialplan = PRI_NATIONAL_ISDN;
+				++c;
+				break;
+			case 'l':
+				pridialplan = PRI_LOCAL_ISDN;
+				++c;
+				break;
+			case 'u':
+				pridialplan = PRI_UNKNOWN;
+				++c;
+				break;
+			case 'p':
+				pridialplan = PRI_PRIVATE;
+				++c;
+				break;
+		}
+
  		pri_sr_set_called(sr, c + p->stripmsd + dp_strip, pridialplan, s ? 1 : 0);
 
 		ldp_strip = 0;
@@ -2100,6 +2126,34 @@
 				prilocaldialplan = PRI_LOCAL_ISDN;
 			}
 		}
+
+		/* override specified pri local dialplan or dynamic pri local
+		   dialplan if explicitly defined in the callerID number */
+		if (l != NULL) {
+			switch (*l) {
+				case 'i':
+					prilocaldialplan = PRI_INTERNATIONAL_ISDN;
+					++l;
+					break;
+				case 'n':
+					prilocaldialplan = PRI_NATIONAL_ISDN;
+					++l;
+					break;
+				case 'l':
+					prilocaldialplan = PRI_LOCAL_ISDN;
+					++l;
+					break;
+				case 'u':
+					prilocaldialplan = PRI_UNKNOWN;
+					++l;
+					break;
+				case 'p':
+					prilocaldialplan = PRI_PRIVATE;
+					++l;
+					break;
+			}
+		}
+
 		pri_sr_set_caller(sr, l ? (l + ldp_strip) : NULL, n, prilocaldialplan,
 			p->use_callingpres ? ast->cid.cid_pres : (l ? PRES_ALLOWED_USER_NUMBER_PASSED_SCREEN : PRES_NUMBER_NOT_AVAILABLE));
 		pri_sr_set_redirecting(sr, ast->cid.cid_rdnis, p->pri->localdialplan - 1, PRES_ALLOWED_USER_NUMBER_PASSED_SCREEN, PRI_REDIR_UNCONDITIONAL);
